; wikiit.nsi

;NSI config file of Wiki'it
;This program is part of "Wiki'it", a free software for
;rapidly getting and modifiying screenshots from clipboards
;and upload them to a MediaWiki server
;
;Copyright (c) 2008-2009 Jean-Philippe Ayanids <jp.ayanides@free.fr>
;license : GPL v.3.0
;see COPYRIGHT for details about license

VIProductVersion 0.9.4

; The name of the installer
Name "Wiki'it"

; The file to write
OutFile "wikiit.exe"
Icon "icons\wikiit-zip.ico"

; The default installation directory
InstallDir $PROGRAMFILES\Wikiit

;;AddBrandingImage (left|right|top|bottom) (width|height) [padding]
AddBrandingImage left 201
;BrandingText /TRIM(LEFT|RIGHT|CENTER) text
BrandingText /TRIMLEFT "Wiki'it installation"

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\Wikiit" "Install_Dir"

; Request application privileges for Windows Vista
RequestExecutionLevel user

LicenseData "LICENSE"
LicenseForceSelection checkbox

LoadLanguageFile French.nlf

ShowInstDetails "nevershow"
;--------------------------------
; Pages

Page license
Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

Function .onGUIInit 
  SetOutPath "$INSTDIR\images"
  File "images\wikiit.bmp"
  SetBrandingImage "$INSTDIR\images\wikiit.bmp"
FunctionEnd

Function un.onGUIInit 
  SetBrandingImage "$INSTDIR\images\wikiit.bmp"
FunctionEnd

Function .onVerifyInstDir
  IfFileExists $INSTDIR\.. PathGood
    Abort
  PathGood:
FunctionEnd

;--------------------------------
Function .onInit
	#System::Call "kernel32::CreateMutexA(i 0, i 0, t $\"$CMDLINE$\") i .r1 ?e"
	System::Call 'kernel32::CreateMutexA(i 0, i 0, t "wikiit.exe") i .r1 ?e'
	Pop $R0
	StrCmp $R0 0 +3
		MessageBox MB_OK|MB_ICONEXCLAMATION "The installer is already running."
		Abort

	ClearErrors
	UserInfo::GetName
	IfErrors autorized +1
	# This one means you don't need to care about admin or not admin because Windows 9x doesn't either

	Pop $0
	UserInfo::GetAccountType
	Pop $1
	# GetOriginalAccountType will check the tokens of the original user of the
	# current thread/process. If the user tokens were elevated or limited for
	# this process, GetOriginalAccountType will return the non-restricted
	# account type.
	# On Vista with UAC, for example, this is not the same value when running
	# with `RequestExecutionLevel user`. GetOriginalAccountType will return
	# "admin" while GetAccountType will return "user".
	UserInfo::GetOriginalAccountType
	Pop $2
	StrCmp $1 "Admin" autorized +1
	StrCmp $1 "Power" autorized +1
	StrCmp $1 "User"  forbidden +1
	StrCmp $1 "Guest" forbidden +1
	MessageBox MB_OK "Unknown error. I try to install however"
		Goto autorized

	autorized:
		#MessageBox MB_OK 'User "$0" is in the $2 and autorized to install'
		Goto done
	forbidden:
		MessageBox MB_ICONEXCLAMATION|MB_OK 'Aborting: user "$0" has insufficient rights to install. '
		Abort
		
	done:
FunctionEnd

;--------------------------------
; The stuff to install
Section "Wikiit (requis)"

	SectionIn RO
	SetOutPath "$INSTDIR"
	File "dist\bz2.pyd"
	File "dist\_imaging.pyd"
	File "dist\MSVCR71.dll"
	File "dist\PIL._imagingft.pyd"
	File "dist\PIL._imaging.pyd"
	File "dist\PIL._imagingtk.pyd"
	File "dist\python25.dll"
	File "dist\pywintypes25.dll"
	File "dist\_socket.pyd"
	File "dist\_ssl.pyd"
	File "dist\tcl84.dll"
	File "dist\tk84.dll"
	File "dist\_tkinter.pyd"
	File "dist\unicodedata.pyd"
	File "dist\w9xpopen.exe"
	File "dist\wikiit.exe"
	File "dist\win32clipboard.pyd"
	
	SetOutPath "$INSTDIR\images"
	File "images\void.png"
	
	SetOutPath "$INSTDIR\icons"
	File "icons\wikiit.ico"
	File "icons\about.png"
	File "icons\clip.png"
	File "icons\color.png"
	File "icons\exit.png"
	File "icons\help.png"
	File "icons\load.png"
	File "icons\menu.png"
	File "icons\minus.png"
	File "icons\plus.png"
	File "icons\save.png"
	File "icons\undo.png"
	File "icons\wizard.png"
	
	SetOutPath "$INSTDIR\tcl\tcl8.4"
	File "dist\tcl\tcl8.4\auto.tcl"
	File "dist\tcl\tcl8.4\history.tcl"
	File "dist\tcl\tcl8.4\init.tcl"
	File "dist\tcl\tcl8.4\ldAout.tcl"
	File "dist\tcl\tcl8.4\package.tcl"
	File "dist\tcl\tcl8.4\parray.tcl"
	File "dist\tcl\tcl8.4\safe.tcl"
	File "dist\tcl\tcl8.4\tclIndex"
	File "dist\tcl\tcl8.4\word.tcl"
	
	SetOutPath "$INSTDIR\tcl\tcl8.4\encoding"
	File "dist\tcl\tcl8.4\encoding\ascii.enc"
	File "dist\tcl\tcl8.4\encoding\big5.enc"
	File "dist\tcl\tcl8.4\encoding\cp1250.enc"
	File "dist\tcl\tcl8.4\encoding\cp1251.enc"
	File "dist\tcl\tcl8.4\encoding\cp1252.enc"
	File "dist\tcl\tcl8.4\encoding\cp1253.enc"
	File "dist\tcl\tcl8.4\encoding\cp1254.enc"
	File "dist\tcl\tcl8.4\encoding\cp1255.enc"
	File "dist\tcl\tcl8.4\encoding\cp1256.enc"
	File "dist\tcl\tcl8.4\encoding\cp1257.enc"
	File "dist\tcl\tcl8.4\encoding\cp1258.enc"
	File "dist\tcl\tcl8.4\encoding\cp437.enc"
	File "dist\tcl\tcl8.4\encoding\cp737.enc"
	File "dist\tcl\tcl8.4\encoding\cp775.enc"
	File "dist\tcl\tcl8.4\encoding\cp850.enc"
	File "dist\tcl\tcl8.4\encoding\cp852.enc"
	File "dist\tcl\tcl8.4\encoding\cp855.enc"
	File "dist\tcl\tcl8.4\encoding\cp857.enc"
	File "dist\tcl\tcl8.4\encoding\cp860.enc"
	File "dist\tcl\tcl8.4\encoding\cp861.enc"
	File "dist\tcl\tcl8.4\encoding\cp862.enc"
	File "dist\tcl\tcl8.4\encoding\cp863.enc"
	File "dist\tcl\tcl8.4\encoding\cp864.enc"
	File "dist\tcl\tcl8.4\encoding\cp865.enc"
	File "dist\tcl\tcl8.4\encoding\cp866.enc"
	File "dist\tcl\tcl8.4\encoding\cp869.enc"
	File "dist\tcl\tcl8.4\encoding\cp874.enc"
	File "dist\tcl\tcl8.4\encoding\cp932.enc"
	File "dist\tcl\tcl8.4\encoding\cp936.enc"
	File "dist\tcl\tcl8.4\encoding\cp949.enc"
	File "dist\tcl\tcl8.4\encoding\cp950.enc"
	File "dist\tcl\tcl8.4\encoding\dingbats.enc"
	File "dist\tcl\tcl8.4\encoding\ebcdic.enc"
	File "dist\tcl\tcl8.4\encoding\euc-cn.enc"
	File "dist\tcl\tcl8.4\encoding\euc-jp.enc"
	File "dist\tcl\tcl8.4\encoding\euc-kr.enc"
	File "dist\tcl\tcl8.4\encoding\gb12345.enc"
	File "dist\tcl\tcl8.4\encoding\gb1988.enc"
	File "dist\tcl\tcl8.4\encoding\gb2312.enc"
	File "dist\tcl\tcl8.4\encoding\gb2312-raw.enc"
	File "dist\tcl\tcl8.4\encoding\iso2022.enc"
	File "dist\tcl\tcl8.4\encoding\iso2022-jp.enc"
	File "dist\tcl\tcl8.4\encoding\iso2022-kr.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-10.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-13.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-14.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-15.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-16.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-1.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-2.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-3.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-4.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-5.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-6.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-7.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-8.enc"
	File "dist\tcl\tcl8.4\encoding\iso8859-9.enc"
	File "dist\tcl\tcl8.4\encoding\jis0201.enc"
	File "dist\tcl\tcl8.4\encoding\jis0208.enc"
	File "dist\tcl\tcl8.4\encoding\jis0212.enc"
	File "dist\tcl\tcl8.4\encoding\koi8-r.enc"
	File "dist\tcl\tcl8.4\encoding\koi8-u.enc"
	File "dist\tcl\tcl8.4\encoding\ksc5601.enc"
	File "dist\tcl\tcl8.4\encoding\macCentEuro.enc"
	File "dist\tcl\tcl8.4\encoding\macCroatian.enc"
	File "dist\tcl\tcl8.4\encoding\macCyrillic.enc"
	File "dist\tcl\tcl8.4\encoding\macDingbats.enc"
	File "dist\tcl\tcl8.4\encoding\macGreek.enc"
	File "dist\tcl\tcl8.4\encoding\macIceland.enc"
	File "dist\tcl\tcl8.4\encoding\macJapan.enc"
	File "dist\tcl\tcl8.4\encoding\macRoman.enc"
	File "dist\tcl\tcl8.4\encoding\macRomania.enc"
	File "dist\tcl\tcl8.4\encoding\macThai.enc"
	File "dist\tcl\tcl8.4\encoding\macTurkish.enc"
	File "dist\tcl\tcl8.4\encoding\macUkraine.enc"
	File "dist\tcl\tcl8.4\encoding\shiftjis.enc"
	File "dist\tcl\tcl8.4\encoding\symbol.enc"
	File "dist\tcl\tcl8.4\encoding\tis-620.enc"
	
	SetOutPath "$INSTDIR\tcl\tcl8.4\http1.0"
	File "dist\tcl\tcl8.4\http1.0\http.tcl"
	File "dist\tcl\tcl8.4\http1.0\pkgIndex.tcl"
	
	SetOutPath "$INSTDIR\tcl\tcl8.4\http2.5"
	File "dist\tcl\tcl8.4\http2.5\http.tcl"
	File "dist\tcl\tcl8.4\http2.5\pkgIndex.tcl"
	
	SetOutPath "$INSTDIR\tcl\tcl8.4\msgcat1.3"
	File "dist\tcl\tcl8.4\msgcat1.3\msgcat.tcl"
	File "dist\tcl\tcl8.4\msgcat1.3\pkgIndex.tcl"
	
	SetOutPath "$INSTDIR\tcl\tcl8.4\opt0.4"
	File "dist\tcl\tcl8.4\opt0.4\optparse.tcl"
	File "dist\tcl\tcl8.4\opt0.4\pkgIndex.tcl"
	
	SetOutPath "$INSTDIR\tcl\tcl8.4\tcltest2.2"
	File "dist\tcl\tcl8.4\tcltest2.2\pkgIndex.tcl"
	File "dist\tcl\tcl8.4\tcltest2.2\tcltest.tcl"
	
	SetOutPath "$INSTDIR\tcl\tk8.4"
	File "dist\tcl\tk8.4\bgerror.tcl"
	File "dist\tcl\tk8.4\button.tcl"
	File "dist\tcl\tk8.4\choosedir.tcl"
	File "dist\tcl\tk8.4\clrpick.tcl"
	File "dist\tcl\tk8.4\comdlg.tcl"
	File "dist\tcl\tk8.4\console.tcl"
	File "dist\tcl\tk8.4\dialog.tcl"
	File "dist\tcl\tk8.4\entry.tcl"
	File "dist\tcl\tk8.4\focus.tcl"
	File "dist\tcl\tk8.4\listbox.tcl"
	File "dist\tcl\tk8.4\menu.tcl"
	File "dist\tcl\tk8.4\mkpsenc.tcl"
	File "dist\tcl\tk8.4\msgbox.tcl"
	File "dist\tcl\tk8.4\obsolete.tcl"
	File "dist\tcl\tk8.4\optMenu.tcl"
	File "dist\tcl\tk8.4\palette.tcl"
	File "dist\tcl\tk8.4\panedwindow.tcl"
	File "dist\tcl\tk8.4\pkgIndex.tcl"
	File "dist\tcl\tk8.4\safetk.tcl"
	File "dist\tcl\tk8.4\scale.tcl"
	File "dist\tcl\tk8.4\scrlbar.tcl"
	File "dist\tcl\tk8.4\spinbox.tcl"
	File "dist\tcl\tk8.4\tclIndex"
	File "dist\tcl\tk8.4\tearoff.tcl"
	File "dist\tcl\tk8.4\text.tcl"
	File "dist\tcl\tk8.4\tkAppInit.c"
	File "dist\tcl\tk8.4\tkfbox.tcl"
	File "dist\tcl\tk8.4\tk.tcl"
	File "dist\tcl\tk8.4\unsupported.tcl"
	File "dist\tcl\tk8.4\xmfbox.tcl"
	
	SetOutPath "$INSTDIR\tcl\tk8.4\msgs"
	File "dist\tcl\tk8.4\msgs\cs.msg"
	File "dist\tcl\tk8.4\msgs\de.msg"
	File "dist\tcl\tk8.4\msgs\el.msg"
	File "dist\tcl\tk8.4\msgs\en_gb.msg"
	File "dist\tcl\tk8.4\msgs\en.msg"
	File "dist\tcl\tk8.4\msgs\eo.msg"
	File "dist\tcl\tk8.4\msgs\es_ES.msg"
	File "dist\tcl\tk8.4\msgs\es.msg"
	File "dist\tcl\tk8.4\msgs\fr.msg"
	File "dist\tcl\tk8.4\msgs\it.msg"
	File "dist\tcl\tk8.4\msgs\nl.msg"
	File "dist\tcl\tk8.4\msgs\pl.msg"
	File "dist\tcl\tk8.4\msgs\pt.msg"
	File "dist\tcl\tk8.4\msgs\ru.msg"
	
	; Write the installation path into the registry
	WriteRegStr HKLM "SOFTWARE\Wikiit" "Install_Dir" "$INSTDIR"
	
	; Write the uninstall keys for Windows
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Wikiit" "DisplayName" "Wiki'it"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Wikiit" "UninstallString" '"$INSTDIR\uninstall.exe"'
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Wikiit" "NoModify" 1
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Wikiit" "NoRepair" 1
	WriteUninstaller "uninstall.exe"
	
	SectionEnd


; Optional section (can be disabled by the user)
Section "Raccourci du menu dmarrer"

;CreateShortCut link.lnk target.file [parameters [icon.file [icon_index_number [start_options [keyboard_shortcut [description]]]]]]
	SetOutPath "$INSTDIR"
	CreateDirectory "$SMPROGRAMS\Wikiit"
	CreateShortCut "$SMPROGRAMS\Wikiit\Wiki'it.lnk" "$INSTDIR\wikiit.exe" "" \
	               "$INSTDIR\icons\wikiit.ico" 0 
	CreateShortCut "$SMPROGRAMS\Wikiit\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" \
	               "$INSTDIR\uninstall.exe" 0
	
SectionEnd

Section "Raccourci sur le bureau"

;CreateShortCut link.lnk target.file [parameters [icon.file [icon_index_number [start_options [keyboard_shortcut [description]]]]]]
	SetOutPath "$INSTDIR"
	CreateShortCut "$DESKTOP\Wiki'it.lnk" "$INSTDIR\wikiit.exe" "" \
	               "$INSTDIR\icons\wikiit.ico" ""\
	               SW_SHOWNORMAL "" \
	               "Screenshot to Mediawiki uploader"
	
SectionEnd
;--------------------------------

; Uninstaller

Section "Uninstall"
  
	; Remove registry keys
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Wikiit"
	DeleteRegKey HKLM "SOFTWARE\Wikiit"
	
	; Remove files 
	Delete "$INSTDIR\images\*.*"
	RMDir  "$INSTDIR\images"
	Delete "$INSTDIR\icons\*.*"
	RMDir  "$INSTDIR\icons"
	Delete "$INSTDIR\tcl\tcl8.4\encoding\*.*"
	RMDir  "$INSTDIR\tcl\tcl8.4\encoding"
	Delete "$INSTDIR\tcl\tcl8.4\http1.0\*.*"
	RMDir  "$INSTDIR\tcl\tcl8.4\http1.0"
	Delete "$INSTDIR\tcl\tcl8.4\http2.5\*.*"
	RMDir  "$INSTDIR\tcl\tcl8.4\http2.5"
	Delete "$INSTDIR\tcl\tcl8.4\msgcat1.3\*.*"
	RMDir  "$INSTDIR\tcl\tcl8.4\msgcat1.3"
	Delete "$INSTDIR\tcl\tcl8.4\opt0.4\*.*"
	RMDir  "$INSTDIR\tcl\tcl8.4\opt0.4"
	Delete "$INSTDIR\tcl\tcl8.4\tcltest2.2\*.*"
	RMDir  "$INSTDIR\tcl\tcl8.4\tcltest2.2"
	Delete "$INSTDIR\tcl\tk8.4\msgs\*.*"
	RMDir  "$INSTDIR\tcl\tk8.4\msgs"
	Delete "$INSTDIR\tcl\tcl8.4\*.*"
	RMDir  "$INSTDIR\tcl\tcl8.4"
	Delete "$INSTDIR\tcl\tk8.4\*.*"
	RMDir  "$INSTDIR\tcl\tk8.4"
	RMDir  "$INSTDIR\tcl"
	Delete "$INSTDIR\*.*"
	RMDir  "$INSTDIR"
	
	; Remove shortcuts, if any
	Delete "$SMPROGRAMS\Wikiit\*.*"
	RMDir  "$SMPROGRAMS\Wikiit"
	Delete "$DESKTOP\Wiki'it.lnk" 

SectionEnd
